/**
 * 
 */
package softwarepulse.db;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

/**
 * @author jmcneil
 * (c) copyright Software Pulse 2016
 *
 */
public class DBManager {
	 private static Connection con;
	 private static boolean hasData = false;
	 
	 /**
	  * Creates a connection to the database 
	  * 
	  * @throws ClassNotFoundException
	  * @throws SQLException
	  */
	 private void getConnection() throws ClassNotFoundException, SQLException {
		  // sqlite driver
		  Class.forName("org.sqlite.JDBC");
		  // database path, if it's new database, it will be created in the project folder
		  con = DriverManager.getConnection("jdbc:sqlite:SQLiteTest1.db");
		  initialise();
	 }
	 

	/**
	 * Passed user, password and salt populates the user table with the information
	 * 
	 * @param user
	 * @param pswd
	 * @param salt
	 * @throws ClassNotFoundException
	 * @throws SQLException
	 */
	 public void addUser(String user, String pswd, String salt) throws ClassNotFoundException, SQLException {
		 if(con == null) {
			 // get connection
			 getConnection();
		 }
		  PreparedStatement prep = con
				    .prepareStatement("insert into users values(?,?,?,?);");
				  prep.setString(2, user);
				  prep.setString(3, pswd);
				  prep.setString(4, salt);
				  prep.execute();
		 
	 }
	 
	/**
	 * returns a result set containing all the user details in the users table
	 *  
	 * @return
	 * @throws SQLException
	 * @throws ClassNotFoundException
	 */
	public ResultSet getUsers() throws SQLException, ClassNotFoundException {
		 if(con == null) {
			 // get connection
			 getConnection();
		 }
		 
		 Statement state = con.createStatement();
		 ResultSet res = state.executeQuery("SELECT id, user, pswd, salt FROM users");
		 return res;
	 }
	 

	 /**
	  * Passed a user name doesa select query on the user table and returns the result set with the result 
	  * 
	  * @param user
	  * @return resultSet
	  * @throws ClassNotFoundException
	  * @throws SQLException
	  */
	 public ResultSet getUser(String user) throws ClassNotFoundException, SQLException {
		 if(con == null) {
			 // get connection
			 getConnection();
		 }

		 String prepSQL = "SELECT user, pswd, salt FROM users WHERE user='" + user + "'";
		 
		 Statement state = con.createStatement();
		 ResultSet res = state.executeQuery(prepSQL);
		 		 
		 return res;
	 }
	 

	 /**
	  * Checks for presence of database table and creates if not found 
	  * @throws SQLException
	  */
	 private void initialise() throws SQLException {
		 if( !hasData ) {
			 // check for database table
			 Statement state = con.createStatement();
			 ResultSet res = state.executeQuery("SELECT name FROM sqlite_master WHERE type='table' AND name='users'");
			 if( !res.next()) {
				 System.out.println("Building the Users table.");
				 // need to build the table
				  Statement state2 = con.createStatement();
				  state2.executeUpdate("create table users(id integer,"
				    + "user varchar(256)," + "pswd varchar(256),"
				    + "salt varchar(256)," + "primary key (id));");

			 }
			 hasData = true;
		 }
	 }
	 

	 /**
	  * Close the database connection
	  * @throws SQLException
	  */
	 public void closeConnection() throws SQLException {
		 con.close();
	 }
}
