/**
 * 
 */
package softwarepulse.app;

import java.awt.BorderLayout;
import java.awt.HeadlessException;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.security.NoSuchAlgorithmException;
import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import softwarepulse.db.DBManager;
import softwarepulse.gui.LoginDialog;
import softwarepulse.util.Authenticate;
import softwarepulse.util.ImageHandler;
import softwarepulse.util.Validate;

/**
 * @author jmcneil
 * (c) copyright Software Pulse 2016
 *
 */
public class App extends JFrame implements ActionListener {

	static Logger log = Logger.getLogger(App.class);
	static App app; 
	
	/**
	 * @throws HeadlessException
	 */
	public App() throws HeadlessException {
		super();
		this.setTitle("Authentication example");
		this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
	}

	
	private void initialise() {
        setTitle("Authentication Example");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setLocation(Toolkit.getDefaultToolkit().getScreenSize().width/3, Toolkit.getDefaultToolkit().getScreenSize().height/3); 
		//setBounds(100, 100, 450, 300);
		
		JPanel backPanel = new JPanel();
		JLabel bgImage = new JLabel();
		ImageIcon bgIcon = new ImageIcon(ImageHandler.getTranslucentPanelImage("bgship.gif", "/softwarepulse/gui", 1.0f));
		bgImage.setIcon(bgIcon);
		backPanel.add(bgImage);

		this.getContentPane().add(backPanel, BorderLayout.CENTER);
		pack();
		setVisible(true);
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		PropertyConfigurator.configure("log4j.properties");

		// create some user in the database
		try {
			if(!Authenticate.createUser("john", "l3tme1n")) {
				log.info("user not added: john");
			}
			if(!Authenticate.createUser("fred", "bloggs")) {
				log.info("user not added: fred");
			}
			if(!Authenticate.createUser("joe", "line")) {
				log.info("user not added: joe");
			}
		} catch (SQLException e1) {
			log.debug("Exception calling Authenticate.createUser()");
			e1.printStackTrace();
		} catch (NoSuchAlgorithmException e1) {
			log.debug("Exception calling Authenticate.createUser()");
			e1.printStackTrace();
		} catch (ClassNotFoundException e1) {
			log.debug("Exception calling Authenticate.createUser()");
			e1.printStackTrace();
		}

		
		app = new App();
		Validate login = new Validate();
		login.addActionListener(app);
		login.Login();
	}

	
	@Override
	public void actionPerformed(ActionEvent e) {
		String cmd;
		cmd = (e.paramString().split("cmd="))[1].split(",")[0];
		
		if(cmd.equals("VALID")) {
			log.debug("App VALID");
			initialise();
			
		} else if(cmd.equals("INVALID")) {
			log.debug("App INVALID - dispose of App");
			app.dispose();
		}
	}
}
