/**
 * 
 */
package softwarepulse.gui;

import java.awt.Color;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.EventListener;

import javax.swing.BorderFactory;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.event.EventListenerList;

import org.apache.log4j.Logger;

import softwarepulse.app.App;

/**
 * @author jmcneil
 * (c) copyright Software Pulse 2016
 *
 */
public class LoginDialog extends JDialog implements ActionListener {
	static Logger log = Logger.getLogger(App.class);

	Login login;
	EventListenerList listeners = new EventListenerList();

	
	/**
	 * 
	 */
	public LoginDialog() {
		super();
		this.setTitle("Login");
		this.setLocation(Toolkit.getDefaultToolkit().getScreenSize().width/3, Toolkit.getDefaultToolkit().getScreenSize().height/3); 
		this.setVisible(true);
		this.setModal(true);
		login = new Login();
		addActionListener(login);
		this.add(login.getPanelLogin());
		JPanel jp = (JPanel)this.getContentPane();
		jp.setBorder(BorderFactory.createLineBorder(Color.GRAY, 1));
		this.pack();

		login.addActionListener(this);
		
		this.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				fireActionPerformed("EXIT");			
				dispose();
			}
		});
		
	}
	
	public String getUserID() {
		return login.getTxtUser().getText();
	}
	
	public String getPswd() {
		return new String(login.getPswd().getPassword());
	}
	

	@Override
	public void actionPerformed(ActionEvent arg0) {
		log.debug("LoginDialog actionPerformed: " + arg0.getActionCommand());
		
		if(arg0.getActionCommand().equals("OK")) {
			// Check login credentials
			fireActionPerformed("YES");
		}
		else if(arg0.getActionCommand().equals("Cancel")) {
			// Exit the application
			fireActionPerformed("EXIT");
			this.dispose();
		} else if(arg0.paramString().split("cmd=")[1].split(",")[0].equals("NOTVALID") ) { 
			fireActionPerformed("NOTAUTH");
		}
	}


	public void addActionListener(ActionListener arg0) {
		listeners.add(ActionListener.class, arg0);
	}
	
	
	protected void fireActionPerformed(String cmd) {
		
		EventListener[] l = listeners.getListeners(ActionListener.class);
		ActionEvent e = null;
		for (int i = 0; i < l.length; i++) {
			if (e == null) {
		    	e = new ActionEvent(this, ActionEvent.ACTION_PERFORMED, cmd);
		    }
		    ((ActionListener) l[i]).actionPerformed(e);	       
		}
	}

}
